#include "tdsutil.h"

unsigned char tds_get_byte(TDSSOCKET *tds)
{
	if (tds->in_pos >= tds->in_len) {
		tds_read_packet(tds);
	}
	return tds->in_buf[tds->in_pos++];
}
void tds_unget_byte(TDSSOCKET *tds)
{
	/* this is a one trick pony...don't call it twice */
	tds->in_pos--;
}
TDS_SMALLINT tds_get_smallint(TDSSOCKET *tds)
{
TDS_SMALLINT ret;
unsigned char hibyte, lobyte;

	lobyte = tds_get_byte(tds);
	hibyte = tds_get_byte(tds);
	return (TDS_SMALLINT) lobyte+(hibyte*256);
}
char *tds_get_n(TDSSOCKET *tds, void *dest, int n)
{
/* FIX ME -- a more direct return of the data if possible, at least memcpy from the buffer area. going byte-by-byte will be slow. */
unsigned char buf[BUFSIZ];
int pos,i;

	pos = 0;
	for (i=0;i<n;i++)
		buf[pos++]=tds_get_byte(tds);	
	
	if (dest==NULL) return NULL;

	memcpy(dest,buf,n);
	return dest;
}
int get_size_by_type(int servertype)
{
	switch(servertype) {
	case SYBINT1: 
		return 1;
		break;
	case SYBINT2: 
		return 2;
		break;
	case SYBINT4: 
		return 4;
		break;
	case SYBFLT8: 
		return 8;
		break;
	case SYBDATETIME: 
		return 8;
		break;
	case SYBDATETIME4: 
		return 8;
		break;
	case SYBBIT: 
		return 1;
		break;
	case SYBMONEY:
		return 8;
		break;
	case SYBMONEY4:
		return 4;
		break;
	}
}
int tds_read_packet (TDSSOCKET *tds)
{
int len;
static unsigned char mybuf[BUFSIZ];

	/* FIX ME -- add packetsize support */
	len = read(tds->s, mybuf, 512); 
	if (mybuf[1]) tds->last_packet=1;
	else tds->last_packet=0;
	tds->in_pos = 0; 
	tds->in_len = len - 8; // skip header stuff
	memcpy(tds->in_buf,&mybuf[8],tds->in_len);
	return tds->in_len;
} 
